//MQL5 Version  June 21, 2010 Final
//+------------------------------------------------------------------+
//|                                         IndicatorsAlgorithms.mqh |
//|                               Copyright  2010, Nikolay Kositsin |
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+
#property copyright "2010,   Nikolay Kositsin"
#property link      "farria@mail.redcom.ru"
#property version   "1.00"

//+------------------------------------------------------------------+
//                                          |
//+------------------------------------------------------------------+
#include <SmoothAlgorithms.mqh> 
//+------------------------------------------------------------------+
//|  -         |
//+------------------------------------------------------------------+
class CLRMA
  {
public:
   double LRMASeries(uint begin,           //     
                     uint prev_calculated, //       
                     uint rates_total,     //       
                     int Length,           //  
                     double series,        //   ,      bar
                     uint bar,             //  
                     bool set              //   .
                     )
     {
      //----   
      double sma,lwma,lrma;

      //----    Moving_Average   SmoothAlgorithms
      // CMoving_Average SMA, LWMA;

      //----     
      sma=m_SMA.SMASeries(begin,prev_calculated,rates_total,Length,series,bar,set);
      lwma=m_LWMA.LWMASeries(begin,prev_calculated,rates_total,Length,series,bar,set);

      //----  LRMA
      lrma=3.0*lwma-2.0*sma;
      //----+
      return(lrma);
     };

protected:
   //----    Moving_Average
   CMoving_Average   m_SMA,m_LWMA;
  };
//+------------------------------------------------------------------+
//|        VIDYA          |
//+------------------------------------------------------------------+
class CVidyaBands
  {
public:
   double VidyaBandsSeries(uint begin,           //     
                           uint prev_calculated, //       
                           uint rates_total,     //       
                           int CMO_period,       //    CMO
                           double EMA_period,    // EMA  
                           int BBLength,         //    
                           double deviation,     // 
                           double series,        //   ,      bar
                           uint bar,             //  
                           bool set,             //   
                           double& DnMovSeries,  //        
                           double& MovSeries,    //        
                           double &UpMovSeries   //        
                           )
     {
      //----       
      MovSeries=m_VIDYA.VIDYASeries(begin,prev_calculated,rates_total,CMO_period,EMA_period,series,bar,set);

      //----   
      double StdDev=m_STD.StdDevSeries(begin+CMO_period+1,prev_calculated,rates_total,BBLength,deviation,series,MovSeries,bar,set);
      DnMovSeries = MovSeries - StdDev;
      UpMovSeries = MovSeries + StdDev;
      //----
      return(StdDev);
     }

protected:
   //----    CCMO  CStdDeviation
   CCMO              m_VIDYA;
   CStdDeviation     m_STD;
  };
//+------------------------------------------------------------------+
//|                                |
//+------------------------------------------------------------------+
class CBBands
  {
public:
   double            BBandsSeries(uint begin,               //     
                                  uint prev_calculated,     //       
                                  uint rates_total,         //       
                                  int Length,               //  
                                  double deviation,         // 
                                  ENUM_MA_METHOD MA_Method, //  
                                  double series,            //   ,      bar
                                  uint bar,                 //  
                                  bool set,                 //   
                                  double& DnMovSeries,      //        
                                  double& MovSeries,        //        
                                  double &UpMovSeries       //        
                                  );

   double            BBandsSeries_(uint begin,              //     
                                   uint prev_calculated,    //       
                                   uint rates_total,        //       
                                   int MALength,            //   
                                   ENUM_MA_METHOD MA_Method,//  
                                   int BBLength,            //    
                                   double deviation,        // 
                                   double series,           //   ,      bar
                                   uint bar,                //  
                                   bool set,                //   
                                   double& DnMovSeries,     //        
                                   double& MovSeries,       //        
                                   double &UpMovSeries      //        
                                   );
protected:
   //----    Moving_Average  CStdDeviation
   CStdDeviation     m_STD;
   CMoving_Average   m_MA;
  };
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
double CBBands::BBandsSeries(uint begin,              //     
                             uint prev_calculated,    //       
                             uint rates_total,        //       
                             int Length,              //  
                             double deviation,        // 
                             ENUM_MA_METHOD MA_Method,//  
                             double series,           //   ,      bar
                             uint bar,                //  
                             bool set,                //   
                             double &DnMovSeries,     //        
                             double &MovSeries,       //       
                             double &UpMovSeries      //       
                             )
// BBandsMASeries(begin, prev_calculated, rates_total, period, deviation,
// MA_Method, Series, bar, set, DnMovSeries, MovSeries, UpMovSeries) 
//+------------------------------------------------------------------+
  {
//----   
   MovSeries=m_MA.MASeries(begin,prev_calculated,rates_total,Length,MA_Method,series,bar,set);

//----   
   double StdDev=m_STD.StdDevSeries(begin,prev_calculated,rates_total,Length,deviation,series,MovSeries,bar,set);
   DnMovSeries = MovSeries - StdDev;
   UpMovSeries = MovSeries + StdDev;
//----+
   return(StdDev);
  }
//+------------------------------------------------------------------+
//|                                       |
//+------------------------------------------------------------------+
double CBBands::BBandsSeries_(uint begin,               //     
                              uint prev_calculated,     //       
                              uint rates_total,         //       
                              int MALength,             //   
                              ENUM_MA_METHOD MA_Method, //  
                              int BBLength,             //    
                              double deviation,         // 
                              double series,            //   ,      bar
                              uint bar,                 //  
                              bool set,                 //   
                              double &DnMovSeries,      //        
                              double &MovSeries,        //       
                              double &UpMovSeries       //       
                              )
// BBandsMASeries_(begin, prev_calculated, rates_total, MALength, MA_Method,
// deviation, BBLength, Series, bar, set, DnMovSeries, MovSeries, UpMovSeries) 
//+------------------------------------------------------------------+
  {
//----   
   MovSeries=m_MA.MASeries(begin,prev_calculated,rates_total,MALength,MA_Method,series,bar,set);

//----   
   double StdDev=m_STD.StdDevSeries(begin+MALength+1,prev_calculated,rates_total,BBLength,deviation,series,MovSeries,bar,set);
   DnMovSeries = MovSeries - StdDev;
   UpMovSeries = MovSeries + StdDev;
//----
   return(StdDev);
  }
//+------------------------------------------------------------------+